/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-Ehm": "E, h:mm a",
	"days-standAlone-short": [
		"нд",
		"пн",
		"вт",
		"ср",
		"чт",
		"пт",
		"сб"
	],
	"months-format-narrow": [
		"я",
		"ф",
		"м",
		"а",
		"м",
		"ю",
		"ю",
		"а",
		"с",
		"о",
		"н",
		"д"
	],
	"field-second-relative+0": "сега",
	"quarters-standAlone-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-weekday": "ден от седмицата",
	"dateFormatItem-yQQQ": "QQQ y 'г'.",
	"dateFormatItem-yMEd": "E, d.MM.y 'г'.",
	"field-wed-relative+0": "тази сряда",
	"field-wed-relative+1": "следващата сряда",
	"dateFormatItem-GyMMMEd": "E, d.MM.y 'г'. G",
	"dateFormatItem-MMMEd": "E, d.MM",
	"eraNarrow": "сл.н.е.",
	"field-tue-relative+-1": "миналият вторник",
	"days-format-short": [
		"нд",
		"пн",
		"вт",
		"ср",
		"чт",
		"пт",
		"сб"
	],
	"dateFormat-long": "d MMMM y 'г'.",
	"field-fri-relative+-1": "миналият петък",
	"field-wed-relative+-1": "миналата сряда",
	"months-format-wide": [
		"януари",
		"февруари",
		"март",
		"април",
		"май",
		"юни",
		"юли",
		"август",
		"септември",
		"октомври",
		"ноември",
		"декември"
	],
	"dateTimeFormat-medium": "{1}, {0}",
	"dateFormatItem-yMMMMd": "d MMMM y 'г'.",
	"dayPeriods-format-wide-pm": "сл.об.",
	"dateFormat-full": "EEEE, d MMMM y 'г'.",
	"field-thu-relative+-1": "миналият четвъртък",
	"dateFormatItem-Md": "d.MM",
	"dateFormatItem-GyMMMM": "MMMM y 'г'. G",
	"dateFormatItem-yMd": "d.MM.y 'г'.",
	"field-era": "ера",
	"dateFormatItem-yM": "M.y 'г'.",
	"months-standAlone-wide": [
		"януари",
		"февруари",
		"март",
		"април",
		"май",
		"юни",
		"юли",
		"август",
		"септември",
		"октомври",
		"ноември",
		"декември"
	],
	"timeFormat-short": "H:mm",
	"quarters-format-wide": [
		"1-во тримесечие",
		"2-ро тримесечие",
		"3-то тримесечие",
		"4-то тримесечие"
	],
	"dateFormatItem-yQQQQ": "QQQQ y 'г'.",
	"timeFormat-long": "H:mm:ss z",
	"field-year": "година",
	"dateFormatItem-yMMM": "MM.y 'г'.",
	"field-hour": "час",
	"months-format-abbr": [
		"ян.",
		"февр.",
		"март",
		"апр.",
		"май",
		"юни",
		"юли",
		"авг.",
		"септ.",
		"окт.",
		"ноем.",
		"дек."
	],
	"field-sat-relative+0": "тази събота",
	"field-sat-relative+1": "следващата събота",
	"timeFormat-full": "H:mm:ss zzzz",
	"field-day-relative+0": "днес",
	"field-thu-relative+0": "този четвъртък",
	"field-day-relative+1": "утре",
	"field-thu-relative+1": "следващият четвъртък",
	"dateFormatItem-GyMMMd": "d.MM.y 'г'. G",
	"field-day-relative+2": "вдругиден",
	"dateFormatItem-H": "H",
	"months-standAlone-abbr": [
		"ян.",
		"февр.",
		"март",
		"апр.",
		"май",
		"юни",
		"юли",
		"авг.",
		"септ.",
		"окт.",
		"ноем.",
		"дек."
	],
	"quarters-format-abbr": [
		"1 трим.",
		"2 трим.",
		"3 трим.",
		"4 трим."
	],
	"quarters-standAlone-wide": [
		"1-во тримесечие",
		"2-ро тримесечие",
		"3-то тримесечие",
		"4-то тримесечие"
	],
	"dateFormatItem-Gy": "y 'г'. G",
	"dateFormatItem-M": "L",
	"days-standAlone-wide": [
		"неделя",
		"понеделник",
		"вторник",
		"сряда",
		"четвъртък",
		"петък",
		"събота"
	],
	"dateFormatItem-MMMMd": "d MMMM",
	"dateFormatItem-GyMMMMd": "d MMMM y 'г'. G",
	"dateFormatItem-MMMM": "LLLL",
	"timeFormat-medium": "H:mm:ss",
	"field-sun-relative+0": "тази неделя",
	"dateFormatItem-Hm": "H:mm",
	"field-sun-relative+1": "следващата неделя",
	"quarters-standAlone-abbr": [
		"1 трим.",
		"2 трим.",
		"3 трим.",
		"4 трим."
	],
	"eraAbbr": [
		"пр.Хр.",
		"пр.н.е.",
		"сл.Хр.",
		"от н.е."
	],
	"field-minute": "минута",
	"field-dayperiod": "пр.об./сл.об.",
	"days-standAlone-abbr": [
		"нд",
		"пн",
		"вт",
		"ср",
		"чт",
		"пт",
		"сб"
	],
	"dateFormatItem-d": "d",
	"dateFormatItem-ms": "m:ss",
	"quarters-format-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-day-relative+-1": "вчера",
	"dateFormatItem-h": "h a",
	"dateTimeFormat-long": "{1}, {0}",
	"field-day-relative+-2": "онзи ден",
	"dateFormatItem-MMMd": "d.MM",
	"dateFormatItem-MEd": "E, d.MM",
	"dateTimeFormat-full": "{1}, {0}",
	"field-fri-relative+0": "този петък",
	"dateFormatItem-yMMMM": "MMMM y 'г'.",
	"field-fri-relative+1": "следващият петък",
	"field-day": "ден",
	"days-format-wide": [
		"неделя",
		"понеделник",
		"вторник",
		"сряда",
		"четвъртък",
		"петък",
		"събота"
	],
	"field-zone": "часова зона",
	"dateFormatItem-y": "y 'г'.",
	"months-standAlone-narrow": [
		"я",
		"ф",
		"м",
		"а",
		"м",
		"ю",
		"ю",
		"а",
		"с",
		"о",
		"н",
		"д"
	],
	"field-year-relative+-1": "миналата година",
	"field-month-relative+-1": "миналият месец",
	"dateFormatItem-hm": "h:mm a",
	"days-format-abbr": [
		"нд",
		"пн",
		"вт",
		"ср",
		"чт",
		"пт",
		"сб"
	],
	"eraNames": [
		"пр.Хр.",
		"сл.Хр.",
		"сл.Хр.",
		"от н.е."
	],
	"dateFormatItem-yMMMd": "d.MM.y 'г'.",
	"days-format-narrow": [
		"н",
		"п",
		"в",
		"с",
		"ч",
		"п",
		"с"
	],
	"days-standAlone-narrow": [
		"н",
		"п",
		"в",
		"с",
		"ч",
		"п",
		"с"
	],
	"dateFormatItem-MMM": "MM",
	"field-month": "месец",
	"field-tue-relative+0": "този вторник",
	"field-tue-relative+1": "следващият вторник",
	"dayPeriods-format-wide-am": "пр.об.",
	"dateFormatItem-MMMMEd": "E, d MMMM",
	"dateFormatItem-EHm": "E HH:mm",
	"dateFormatItem-MMMMdd": "d MMMM",
	"field-mon-relative+0": "този понеделник",
	"field-mon-relative+1": "следващият понеделник",
	"dateFormat-short": "d.MM.yy",
	"dateFormatItem-EHms": "E, H:mm:ss",
	"dateFormatItem-yMMMMEd": "E, d MMMM y 'г'.",
	"dateFormatItem-Ehms": "E h:mm:ss a",
	"field-second": "секунда",
	"field-sat-relative+-1": "миналата събота",
	"dateFormatItem-yMMMEd": "E, d.MM.y 'г'.",
	"field-sun-relative+-1": "миналата неделя",
	"field-month-relative+0": "този месец",
	"field-month-relative+1": "следващият месец",
	"dateFormatItem-Ed": "E, d",
	"dateTimeFormats-appendItem-Timezone": "{0} {1}",
	"field-week": "седмица",
	"dateFormat-medium": "d.MM.y 'г'.",
	"field-year-relative+0": "тази година",
	"field-week-relative+-1": "миналата седмица",
	"field-year-relative+1": "следващата година",
	"dateTimeFormat-short": "{1}, {0}",
	"dateFormatItem-Hms": "H:mm:ss",
	"dateFormatItem-hms": "h:mm:ss a",
	"dateFormatItem-GyMMM": "MM.y 'г'. G",
	"dateFormatItem-GyMMMMEd": "E, d MMMM y 'г'. G",
	"field-mon-relative+-1": "миналият понеделник",
	"field-week-relative+0": "тази седмица",
	"field-week-relative+1": "следващата седмица"
}
//end v1.x content
);
