/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-Ehm": "E h:mm a",
	"days-standAlone-short": [
		"do.",
		"lu.",
		"ma.",
		"mi.",
		"ju.",
		"vi.",
		"sá."
	],
	"months-format-narrow": [
		"E",
		"F",
		"Ma",
		"A",
		"My",
		"Jn",
		"Jl",
		"Ag",
		"S",
		"O",
		"N",
		"D"
	],
	"quarters-standAlone-narrow": [
		"1T",
		"2T",
		"3T",
		"4T"
	],
	"field-weekday": "Día de la semana",
	"dateFormatItem-yQQQ": "QQQ y",
	"dateFormatItem-yMEd": "E d/M/y",
	"field-wed-relative+0": "este miércoles",
	"field-wed-relative+1": "el miércoles próximo",
	"dateFormatItem-GyMMMEd": "E, d 'de' MMMM 'de' y G",
	"dateFormatItem-MMMEd": "E d 'de' MMM",
	"eraNarrow": [
		"a.C.",
		"a. e. c.",
		"d.C.",
		"e. c."
	],
	"dateFormatItem-yMM": "MM/y",
	"field-tue-relative+-1": "el martes pasado",
	"dateFormatItem-MMMdd": "dd-MMM",
	"days-format-short": [
		"do.",
		"lu.",
		"ma.",
		"mi.",
		"ju.",
		"vi.",
		"sá."
	],
	"dateFormat-long": "d 'de' MMMM 'de' y",
	"field-fri-relative+-1": "el viernes pasado",
	"field-wed-relative+-1": "el miércoles pasado",
	"months-format-wide": [
		"enero",
		"febrero",
		"marzo",
		"abril",
		"mayo",
		"junio",
		"julio",
		"agosto",
		"septiembre",
		"octubre",
		"noviembre",
		"diciembre"
	],
	"dateTimeFormat-medium": "{1} {0}",
	"dayPeriods-format-wide-pm": "p.m.",
	"dateFormat-full": "EEEE, d 'de' MMMM 'de' y",
	"field-thu-relative+-1": "el jueves pasado",
	"dateFormatItem-Md": "d/M",
	"dateFormatItem-yMd": "d/M/y",
	"field-era": "era",
	"dateFormatItem-yM": "M/y",
	"months-standAlone-wide": [
		"enero",
		"febrero",
		"marzo",
		"abril",
		"mayo",
		"junio",
		"julio",
		"agosto",
		"septiembre",
		"octubre",
		"noviembre",
		"diciembre"
	],
	"timeFormat-short": "HH:mm",
	"quarters-format-wide": [
		"1.er trimestre",
		"2.º trimestre",
		"3.er trimestre",
		"4.º trimestre"
	],
	"dateFormatItem-yQQQQ": "QQQQ 'de' y",
	"timeFormat-long": "HH:mm:ss z",
	"field-year": "Año",
	"dateFormatItem-yMMM": "MMM 'de' y",
	"field-hour": "Hora",
	"dateFormatItem-MMdd": "dd/MM",
	"months-format-abbr": [
		"ene.",
		"febr.",
		"mzo.",
		"abr.",
		"my.",
		"jun.",
		"jul.",
		"ag.",
		"set.",
		"oct.",
		"nov.",
		"dic."
	],
	"field-sat-relative+0": "este sábado",
	"field-sat-relative+1": "el sábado próximo",
	"timeFormat-full": "HH:mm:ss zzzz",
	"field-day-relative+0": "hoy",
	"field-thu-relative+0": "este jueves",
	"field-day-relative+1": "mañana",
	"field-thu-relative+1": "el jueves próximo",
	"dateFormatItem-GyMMMd": "d MMM y G",
	"field-day-relative+2": "pasado mañana",
	"dateFormatItem-H": "HH",
	"months-standAlone-abbr": [
		"en.",
		"febr.",
		"mzo.",
		"abr.",
		"my.",
		"jun",
		"jul",
		"ag.",
		"set.",
		"oct.",
		"nov.",
		"dic."
	],
	"quarters-format-abbr": [
		"T1",
		"T2",
		"T3",
		"T4"
	],
	"quarters-standAlone-wide": [
		"1.er trimestre",
		"2.º trimestre",
		"3.er trimestre",
		"4.º trimestre"
	],
	"dateFormatItem-Gy": "y G",
	"dateFormatItem-M": "L",
	"days-standAlone-wide": [
		"domingo",
		"lunes",
		"martes",
		"miércoles",
		"jueves",
		"viernes",
		"sábado"
	],
	"dateFormatItem-MMMMd": "d 'de' MMMM",
	"timeFormat-medium": "HH:mm:ss",
	"field-sun-relative+0": "este domingo",
	"dateFormatItem-Hm": "HH:mm",
	"field-sun-relative+1": "el domingo próximo",
	"quarters-standAlone-abbr": [
		"T1",
		"T2",
		"T3",
		"T4"
	],
	"eraAbbr": [
		"a.C.",
		"a. e. c.",
		"d.C.",
		"e. c."
	],
	"field-minute": "Minuto",
	"field-dayperiod": "a.m./p.m.",
	"days-standAlone-abbr": [
		"dom.",
		"lun",
		"mar.",
		"mié.",
		"jue.",
		"vie",
		"sáb."
	],
	"dateFormatItem-d": "d",
	"dateFormatItem-ms": "mm:ss",
	"quarters-format-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-day-relative+-1": "ayer",
	"dateFormatItem-h": "hh a",
	"dateTimeFormat-long": "{1} {0}",
	"field-day-relative+-2": "antes de ayer",
	"dateFormatItem-MMMd": "d 'de' MMM",
	"dateFormatItem-MEd": "E, d/M",
	"dateTimeFormat-full": "{1} {0}",
	"field-fri-relative+0": "este viernes",
	"dateFormatItem-yMMMM": "MMMM 'de' y",
	"field-fri-relative+1": "el viernes próximo",
	"field-day": "Día",
	"days-format-wide": [
		"domingo",
		"lunes",
		"martes",
		"miércoles",
		"jueves",
		"viernes",
		"sábado"
	],
	"field-zone": "Zona horaria",
	"dateFormatItem-y": "y",
	"months-standAlone-narrow": [
		"E",
		"F",
		"Ma",
		"A",
		"My",
		"Jn",
		"Jl",
		"Ag",
		"S",
		"O",
		"N",
		"D"
	],
	"field-year-relative+-1": "el año pasado",
	"field-month-relative+-1": "el mes pasado",
	"dateFormatItem-hm": "hh:mm a",
	"days-format-abbr": [
		"dom.",
		"lun.",
		"mar.",
		"miér.",
		"jue.",
		"vier.",
		"sáb"
	],
	"dateFormatItem-yMMMd": "d 'de' MMM 'de' y",
	"eraNames": [
		"a.C.",
		"a. e. c.",
		"d.C.",
		"e. c."
	],
	"days-format-narrow": [
		"D",
		"L",
		"M",
		"X",
		"J",
		"V",
		"S"
	],
	"days-standAlone-narrow": [
		"D",
		"L",
		"M",
		"X",
		"J",
		"V",
		"S"
	],
	"dateFormatItem-MMM": "LLL",
	"field-month": "Mes",
	"field-tue-relative+0": "este martes",
	"field-tue-relative+1": "el martes próximo",
	"dayPeriods-format-wide-am": "a.m.",
	"dateFormatItem-EHm": "E H:mm",
	"field-mon-relative+0": "este lunes",
	"field-mon-relative+1": "el lunes próximo",
	"dateFormat-short": "dd/MM/yy",
	"dateFormatItem-MMd": "d/MM",
	"dateFormatItem-EHms": "E H:mm:ss",
	"dateFormatItem-Ehms": "E h:mm:ss a",
	"field-second": "Segundo",
	"field-sat-relative+-1": "el sábado pasado",
	"dateFormatItem-yMMMEd": "EEE, d 'de' MMMM 'de' y",
	"field-sun-relative+-1": "el domingo pasado",
	"field-month-relative+0": "este mes",
	"field-month-relative+1": "el mes próximo",
	"dateFormatItem-Ed": "E d",
	"dateTimeFormats-appendItem-Timezone": "{0} {1}",
	"field-week": "Semana",
	"dateFormat-medium": "dd/MM/y",
	"field-year-relative+0": "este año",
	"field-week-relative+-1": "la semana pasada",
	"field-year-relative+1": "el año próximo",
	"dateTimeFormat-short": "{1} {0}",
	"dateFormatItem-Hms": "HH:mm:ss",
	"dateFormatItem-hms": "hh:mm:ss a",
	"dateFormatItem-GyMMM": "MMM y G",
	"field-mon-relative+-1": "el lunes pasado",
	"field-week-relative+0": "esta semana",
	"field-week-relative+1": "la semana próxima"
}
//end v1.x content
);
