/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-yyyyMMMEd": "E d MMM y G",
	"dayPeriods-format-wide-pm": "بعدازظهر",
	"eraNames": [
		"ه. ش."
	],
	"dateFormatItem-MMMEd": "E d LLL",
	"dateTimeFormat-full": "{1}، ساعت {0}",
	"days-standAlone-wide": [
		"یکشنبه",
		"دوشنبه",
		"سهشنبه",
		"چهارشنبه",
		"پنجشنبه",
		"جمعه",
		"شنبه"
	],
	"months-standAlone-narrow": [
		"ح",
		"ث",
		"ج",
		"س",
		"ا",
		"س",
		"م",
		"ع",
		"ق",
		"ج",
		"د",
		"ح"
	],
	"dateTimeFormat-short": "{1}، {0}",
	"dateFormatItem-Gy": "y G",
	"dayPeriods-format-wide-am": "قبلازظهر",
	"dateTimeFormat-medium": "{1}، {0}",
	"quarters-standAlone-abbr": [
		"سم۱",
		"سم۲",
		"سم۳",
		"سم۴"
	],
	"dateFormatItem-y": "y G",
	"timeFormat-full": "H:mm:ss (zzzz)",
	"dateTimeFormats-appendItem-Timezone": "{0} ({1})",
	"dateFormatItem-yyyy": "y G",
	"months-standAlone-abbr": [
		"حمل",
		"ثور",
		"جوزا",
		"سرطان",
		"اسد",
		"سنبلهٔ",
		"میزان",
		"عقرب",
		"قوس",
		"جدی",
		"دلو",
		"حوت"
	],
	"dateFormatItem-Ed": "E d",
	"days-standAlone-narrow": [
		"ی",
		"د",
		"س",
		"چ",
		"پ",
		"ج",
		"ش"
	],
	"eraAbbr": [
		"ه. ش."
	],
	"dateFormatItem-GyMMMd": "d MMM y G",
	"dateFormat-long": "d MMMM y G",
	"timeFormat-medium": "H:mm:ss",
	"dateFormatItem-Hm": "H:mm",
	"dateFormat-medium": "d MMM y G",
	"dateFormatItem-Hms": "H:mm:ss",
	"quarters-standAlone-wide": [
		"سهماههٔ اول",
		"سهماههٔ دوم",
		"سهماههٔ سوم",
		"سهماههٔ چهارم"
	],
	"dateFormatItem-yyyyQQQQ": "QQQQ y G",
	"quarters-standAlone-narrow": [
		"۱",
		"۲",
		"۳",
		"۴"
	],
	"dateTimeFormat-long": "{1}، ساعت {0}",
	"months-standAlone-wide": [
		"حمل",
		"ثور",
		"جوزا",
		"سرطان",
		"اسد",
		"سنبلهٔ",
		"میزان",
		"عقرب",
		"قوس",
		"جدی",
		"دلو",
		"حوت"
	],
	"dateFormatItem-yyyyMd": "y/M/d G",
	"dateFormatItem-yyyyMMMd": "d MMM y G",
	"dateFormatItem-yyyyMEd": "E y/M/d G",
	"dateFormatItem-MMMd": "d LLL",
	"quarters-format-narrow": [
		"۱",
		"۲",
		"۳",
		"۴"
	],
	"months-format-abbr": [
		"حمل",
		"ثور",
		"جوزا",
		"سرطان",
		"اسد",
		"سنبلهٔ",
		"میزان",
		"عقرب",
		"قوس",
		"جدی",
		"دلو",
		"حوت"
	],
	"timeFormat-long": "H:mm:ss (z)",
	"dayPeriods-format-wide-noon": "ظهر",
	"dateFormatItem-H": "H",
	"timeFormat-short": "H:mm",
	"quarters-format-abbr": [
		"سم۱",
		"سم۲",
		"سم۳",
		"سم۴"
	],
	"days-format-abbr": [
		"یکشنبه",
		"دوشنبه",
		"سهشنبه",
		"چهارشنبه",
		"پنجشنبه",
		"جمعه",
		"شنبه"
	],
	"days-format-narrow": [
		"ی",
		"د",
		"س",
		"چ",
		"پ",
		"ج",
		"ش"
	],
	"dateFormatItem-GyMMMEd": "E d MMM y G",
	"dateFormatItem-GyMMM": "MMM y G",
	"dateFormatItem-yyyyQQQ": "QQQQ y G",
	"dateFormatItem-MEd": "E M/d",
	"dateTimeFormats-appendItem-Day-Of-Week": "{1} {0}",
	"months-format-narrow": [
		"ح",
		"ث",
		"ج",
		"س",
		"ا",
		"س",
		"م",
		"ع",
		"ق",
		"ج",
		"د",
		"ح"
	],
	"days-standAlone-short": [
		"۱ش",
		"۲ش",
		"۳ش",
		"۴ش",
		"۵ش",
		"ج",
		"ش"
	],
	"days-standAlone-abbr": [
		"یکشنبه",
		"دوشنبه",
		"سهشنبه",
		"چهارشنبه",
		"پنجشنبه",
		"جمعه",
		"شنبه"
	],
	"dateFormat-short": "y/M/d G",
	"dateFormatItem-yyyyM": "y/M G",
	"dateFormat-full": "EEEE d MMMM y G",
	"dateFormatItem-Md": "M/d",
	"months-format-wide": [
		"حمل",
		"ثور",
		"جوزا",
		"سرطان",
		"اسد",
		"سنبلهٔ",
		"میزان",
		"عقرب",
		"قوس",
		"جدی",
		"دلو",
		"حوت"
	],
	"days-format-short": [
		"۱ش",
		"۲ش",
		"۳ش",
		"۴ش",
		"۵ش",
		"ج",
		"ش"
	],
	"dateFormatItem-yyyyMMM": "MMM y G",
	"quarters-format-wide": [
		"سهماههٔ اول",
		"سهماههٔ دوم",
		"سهماههٔ سوم",
		"سهماههٔ چهارم"
	],
	"eraNarrow": [
		"ه. ش."
	],
	"days-format-wide": [
		"یکشنبه",
		"دوشنبه",
		"سهشنبه",
		"چهارشنبه",
		"پنجشنبه",
		"جمعه",
		"شنبه"
	]
}
//end v1.x content
);
