/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-Ehm": "E h:mm a",
	"days-standAlone-short": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"months-format-narrow": [
		"ज",
		"फ़",
		"मा",
		"अ",
		"म",
		"जू",
		"जु",
		"अ",
		"सि",
		"अ",
		"न",
		"दि"
	],
	"field-second-relative+0": "अब",
	"quarters-standAlone-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-weekday": "सप्ताह का दिन",
	"dateFormatItem-yQQQ": "QQQ y",
	"dateFormatItem-yMEd": "E, d/M/y",
	"field-wed-relative+0": "यह बुधवार",
	"field-wed-relative+1": "अगला बुधवार",
	"dateFormatItem-GyMMMEd": "E, d MMM, G y",
	"dateFormatItem-MMMEd": "E, d MMM",
	"eraNarrow": [
		"ईसा-पूर्व",
		"ईस्वी"
	],
	"dateFormatItem-yMM": "MM-y",
	"field-tue-relative+-1": "पिछला मंगलवार",
	"days-format-short": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"dateFormat-long": "d MMMM y",
	"field-fri-relative+-1": "पिछला शुक्रवार",
	"field-wed-relative+-1": "पिछला बुधवार",
	"months-format-wide": [
		"जनवरी",
		"फ़रवरी",
		"मार्च",
		"अप्रैल",
		"मई",
		"जून",
		"जुलाई",
		"अगस्त",
		"सितंबर",
		"अक्टूबर",
		"नवंबर",
		"दिसंबर"
	],
	"dateTimeFormat-medium": "{1}, {0}",
	"dayPeriods-format-wide-pm": "अपराह्न",
	"dateFormat-full": "EEEE, d MMMM y",
	"field-thu-relative+-1": "पिछला गुरुवार",
	"dateFormatItem-Md": "d/M",
	"dayPeriods-format-abbr-am": "पूर्व",
	"dateFormatItem-yMd": "d/M/y",
	"field-era": "युग",
	"dateFormatItem-yM": "M/y",
	"months-standAlone-wide": [
		"जनवरी",
		"फ़रवरी",
		"मार्च",
		"अप्रैल",
		"मई",
		"जून",
		"जुलाई",
		"अगस्त",
		"सितंबर",
		"अक्टूबर",
		"नवंबर",
		"दिसंबर"
	],
	"timeFormat-short": "h:mm a",
	"quarters-format-wide": [
		"पहली तिमाही",
		"दूसरी तिमाही",
		"तीसरी तिमाही",
		"चौथी तिमाही"
	],
	"dateFormatItem-yQQQQ": "QQQQ y",
	"timeFormat-long": "h:mm:ss a z",
	"field-year": "वर्ष",
	"dateFormatItem-yMMM": "MMM y",
	"field-hour": "घंटा",
	"dateFormatItem-MMdd": "dd-MM",
	"months-format-abbr": [
		"जन",
		"फ़र",
		"मार्च",
		"अप्रै",
		"मई",
		"जून",
		"जुला",
		"अग",
		"सितं",
		"अक्टू",
		"नवं",
		"दिसं"
	],
	"field-sat-relative+0": "यह शनिवार",
	"field-sat-relative+1": "अगला शनिवार",
	"timeFormat-full": "h:mm:ss a zzzz",
	"field-day-relative+0": "आज",
	"field-thu-relative+0": "यह गुरुवार",
	"field-day-relative+1": "आने वाला कल",
	"field-thu-relative+1": "अगला गुरुवार",
	"dateFormatItem-GyMMMd": "d MMM, G y",
	"field-day-relative+2": "परसों",
	"dateFormatItem-H": "HH",
	"months-standAlone-abbr": [
		"जन",
		"फ़र",
		"मार्च",
		"अप्रै",
		"मई",
		"जून",
		"जुला",
		"अग",
		"सितं",
		"अक्टू",
		"नवं",
		"दिसं"
	],
	"quarters-format-abbr": [
		"ति1",
		"ति2",
		"ति3",
		"ति4"
	],
	"quarters-standAlone-wide": [
		"पहली तिमाही",
		"दूसरी तिमाही",
		"तीसरी तिमाही",
		"चौथी तिमाही"
	],
	"dateFormatItem-Gy": "y G",
	"dateFormatItem-M": "L",
	"days-standAlone-wide": [
		"रविवार",
		"सोमवार",
		"मंगलवार",
		"बुधवार",
		"गुरुवार",
		"शुक्रवार",
		"शनिवार"
	],
	"dateFormatItem-MMMMd": "d MMMM",
	"timeFormat-medium": "h:mm:ss a",
	"dateFormatItem-yMMdd": "dd-MM-y",
	"field-sun-relative+0": "यह रविवार",
	"dateFormatItem-Hm": "HH:mm",
	"field-sun-relative+1": "अगला रविवार",
	"quarters-standAlone-abbr": [
		"ति1",
		"ति2",
		"ति3",
		"ति4"
	],
	"eraAbbr": [
		"ईसा-पूर्व",
		"ईस्वी"
	],
	"field-minute": "मिनट",
	"field-dayperiod": "AM/PM",
	"days-standAlone-abbr": [
		"रवि",
		"सोम",
		"मंगल",
		"बुध",
		"गुरु",
		"शुक्र",
		"शनि"
	],
	"dateFormatItem-d": "d",
	"dateFormatItem-ms": "mm:ss",
	"quarters-format-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-day-relative+-1": "बीता कल",
	"dateFormatItem-h": "h a",
	"dateTimeFormat-long": "{1} को {0}",
	"dayPeriods-format-narrow-am": "पू",
	"field-day-relative+-2": "बीता परसों",
	"dateFormatItem-MMMd": "d MMM",
	"dateFormatItem-MEd": "E, d/M",
	"dateTimeFormat-full": "{1} को {0}",
	"field-fri-relative+0": "यह शुक्रवार",
	"dateFormatItem-yMMMM": "MMMM y",
	"field-fri-relative+1": "अगला शुक्रवार",
	"field-day": "दिन",
	"days-format-wide": [
		"रविवार",
		"सोमवार",
		"मंगलवार",
		"बुधवार",
		"गुरुवार",
		"शुक्रवार",
		"शनिवार"
	],
	"field-zone": "समय क्षेत्र",
	"dateFormatItem-y": "y",
	"months-standAlone-narrow": [
		"ज",
		"फ़",
		"मा",
		"अ",
		"म",
		"जू",
		"जु",
		"अ",
		"सि",
		"अ",
		"न",
		"दि"
	],
	"field-year-relative+-1": "पिछला वर्ष",
	"field-month-relative+-1": "पिछला माह",
	"dateFormatItem-hm": "h:mm a",
	"dayPeriods-format-abbr-pm": "अपर",
	"days-format-abbr": [
		"रवि",
		"सोम",
		"मंगल",
		"बुध",
		"गुरु",
		"शुक्र",
		"शनि"
	],
	"dateFormatItem-yMMMd": "d MMM, y",
	"eraNames": [
		"ईसा-पूर्व",
		"ईस्वी"
	],
	"days-format-narrow": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"days-standAlone-narrow": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"dateFormatItem-MMM": "LLL",
	"field-month": "माह",
	"field-tue-relative+0": "यह मंगलवार",
	"field-tue-relative+1": "अगला मंगलवार",
	"dayPeriods-format-wide-am": "पूर्वाह्न",
	"dateFormatItem-MMMMEd": "E, d MMMM",
	"dateFormatItem-EHm": "E HH:mm",
	"field-mon-relative+0": "यह सोमवार",
	"field-mon-relative+1": "अगला सोमवार",
	"dateFormat-short": "d-M-yy",
	"dateFormatItem-EHms": "E HH:mm:ss",
	"dateFormatItem-Ehms": "E h:mm:ss a",
	"field-second": "सेकंड",
	"field-sat-relative+-1": "पिछला शनिवार",
	"dateFormatItem-yMMMEd": "E, d MMM y",
	"field-sun-relative+-1": "पिछला रविवार",
	"field-month-relative+0": "यह माह",
	"field-month-relative+1": "अगला माह",
	"dateFormatItem-Ed": "E d",
	"dateTimeFormats-appendItem-Timezone": "{0} {1}",
	"field-week": "सप्ताह",
	"dateFormat-medium": "dd-MM-y",
	"field-year-relative+0": "यह वर्ष",
	"field-week-relative+-1": "पिछला सप्ताह",
	"field-year-relative+1": "अगला वर्ष",
	"dayPeriods-format-narrow-pm": "अ",
	"dateTimeFormat-short": "{1}, {0}",
	"dateFormatItem-Hms": "HH:mm:ss",
	"dateFormatItem-hms": "h:mm:ss a",
	"dateFormatItem-GyMMM": "MMM G y",
	"field-mon-relative+-1": "पिछला सोमवार",
	"field-week-relative+0": "यह सप्ताह",
	"field-week-relative+1": "अगला सप्ताह"
}
//end v1.x content
);
