/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-Ehm": "E, h:mm a",
	"days-standAlone-short": [
		"su.",
		"má.",
		"þr.",
		"mi.",
		"fi.",
		"fö.",
		"la."
	],
	"months-format-narrow": [
		"J",
		"F",
		"M",
		"A",
		"M",
		"J",
		"J",
		"Á",
		"S",
		"O",
		"N",
		"D"
	],
	"field-second-relative+0": "núna",
	"quarters-standAlone-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-weekday": "vikudagur",
	"dateFormatItem-yQQQ": "QQQ y",
	"dateFormatItem-yMEd": "E, d.M.y",
	"field-wed-relative+0": "miðvikudagur í þessari viku",
	"field-wed-relative+1": "miðvikudagur í næstu viku",
	"dateFormatItem-GyMMMEd": "E, d. MMM y G",
	"dateFormatItem-MMMEd": "E, d. MMM",
	"eraNarrow": [
		"f.k.",
		"e.k."
	],
	"field-tue-relative+-1": "þriðjudagur í síðustu viku",
	"days-format-short": [
		"su.",
		"má.",
		"þr.",
		"mi.",
		"fi.",
		"fö.",
		"la."
	],
	"dateFormat-long": "d. MMMM y",
	"field-fri-relative+-1": "föstudagur í síðustu viku",
	"field-wed-relative+-1": "miðvikudagur í síðustu viku",
	"months-format-wide": [
		"janúar",
		"febrúar",
		"mars",
		"apríl",
		"maí",
		"júní",
		"júlí",
		"ágúst",
		"september",
		"október",
		"nóvember",
		"desember"
	],
	"dateTimeFormat-medium": "{1}, {0}",
	"dayPeriods-format-wide-pm": "e.h.",
	"dateFormat-full": "EEEE, d. MMMM y",
	"field-thu-relative+-1": "fimmtudagur í síðustu viku",
	"dateFormatItem-Md": "d.M.",
	"dateFormatItem-yMd": "d.M.y",
	"field-era": "tímabil",
	"dateFormatItem-yM": "M. y",
	"months-standAlone-wide": [
		"janúar",
		"febrúar",
		"mars",
		"apríl",
		"maí",
		"júní",
		"júlí",
		"ágúst",
		"september",
		"október",
		"nóvember",
		"desember"
	],
	"timeFormat-short": "HH:mm",
	"quarters-format-wide": [
		"1. fjórðungur",
		"2. fjórðungur",
		"3. fjórðungur",
		"4. fjórðungur"
	],
	"dateFormatItem-yQQQQ": "QQQQ y",
	"timeFormat-long": "HH:mm:ss z",
	"field-year": "ár",
	"dateFormatItem-yMMM": "MMM y",
	"field-hour": "klukkustund",
	"months-format-abbr": [
		"jan.",
		"feb.",
		"mar.",
		"apr.",
		"maí",
		"jún.",
		"júl.",
		"ágú.",
		"sep.",
		"okt.",
		"nóv.",
		"des."
	],
	"field-sat-relative+0": "laugardagur í þessari viku",
	"field-sat-relative+1": "laugardagur í næstu viku",
	"timeFormat-full": "HH:mm:ss zzzz",
	"field-day-relative+0": "í dag",
	"field-thu-relative+0": "fimmtudagur í þessari viku",
	"field-day-relative+1": "á morgun",
	"field-thu-relative+1": "fimmtudagur í næstu viku",
	"dateFormatItem-GyMMMd": "d. MMM y G",
	"field-day-relative+2": "eftir tvo daga",
	"dateFormatItem-H": "HH",
	"months-standAlone-abbr": [
		"jan.",
		"feb.",
		"mar.",
		"apr.",
		"maí",
		"jún.",
		"júl.",
		"ágú.",
		"sep.",
		"okt.",
		"nóv.",
		"des."
	],
	"quarters-format-abbr": [
		"F1",
		"F2",
		"F3",
		"F4"
	],
	"quarters-standAlone-wide": [
		"1. fjórðungur",
		"2. fjórðungur",
		"3. fjórðungur",
		"4. fjórðungur"
	],
	"dateFormatItem-Gy": "y G",
	"dateFormatItem-M": "L",
	"days-standAlone-wide": [
		"sunnudagur",
		"mánudagur",
		"þriðjudagur",
		"miðvikudagur",
		"fimmtudagur",
		"föstudagur",
		"laugardagur"
	],
	"dateFormatItem-MMMMd": "d. MMMM",
	"timeFormat-medium": "HH:mm:ss",
	"field-sun-relative+0": "sunnudagur í þessari viku",
	"dateFormatItem-Hm": "HH:mm",
	"field-sun-relative+1": "sunnudagur í næstu viku",
	"quarters-standAlone-abbr": [
		"F1",
		"F2",
		"F3",
		"F4"
	],
	"eraAbbr": [
		"f.Kr.",
		"e.Kr."
	],
	"field-minute": "mínúta",
	"field-dayperiod": "f.h./e.h.",
	"days-standAlone-abbr": [
		"sun.",
		"mán.",
		"þri.",
		"mið.",
		"fim.",
		"fös.",
		"lau."
	],
	"dateFormatItem-d": "d",
	"dateFormatItem-ms": "mm:ss",
	"quarters-format-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-day-relative+-1": "í gær",
	"dateFormatItem-h": "h a",
	"dateTimeFormat-long": "{1} 'kl.' {0}",
	"dayPeriods-format-narrow-am": "f.h.",
	"field-day-relative+-2": "í fyrradag",
	"dateFormatItem-MMMd": "d. MMM",
	"dateFormatItem-MEd": "E, d.M.",
	"dateTimeFormat-full": "{1} 'kl.' {0}",
	"field-fri-relative+0": "föstudagur í þessari viku",
	"dateFormatItem-yMMMM": "MMMM y",
	"field-fri-relative+1": "föstudagur í næstu viku",
	"field-day": "dagur",
	"days-format-wide": [
		"sunnudagur",
		"mánudagur",
		"þriðjudagur",
		"miðvikudagur",
		"fimmtudagur",
		"föstudagur",
		"laugardagur"
	],
	"field-zone": "tímabelti",
	"dateFormatItem-y": "y",
	"months-standAlone-narrow": [
		"J",
		"F",
		"M",
		"A",
		"M",
		"J",
		"J",
		"Á",
		"S",
		"O",
		"N",
		"D"
	],
	"field-year-relative+-1": "á síðasta ári",
	"field-month-relative+-1": "í síðasta mánuði",
	"dateFormatItem-hm": "h:mm a",
	"days-format-abbr": [
		"sun.",
		"mán.",
		"þri.",
		"mið.",
		"fim.",
		"fös.",
		"lau."
	],
	"dateFormatItem-yMMMd": "d. MMM y",
	"eraNames": [
		"f.Kr.",
		"e.Kr."
	],
	"days-format-narrow": [
		"S",
		"M",
		"Þ",
		"M",
		"F",
		"F",
		"L"
	],
	"days-standAlone-narrow": [
		"S",
		"M",
		"Þ",
		"M",
		"F",
		"F",
		"L"
	],
	"dateFormatItem-MMM": "LLL",
	"field-month": "mánuður",
	"field-tue-relative+0": "þriðjudagur í þessari viku",
	"field-tue-relative+1": "þriðjudagur í næstu viku",
	"dayPeriods-format-wide-am": "f.h.",
	"dateFormatItem-MMMMEd": "E, d. MMMM",
	"dateFormatItem-EHm": "E, HH:mm",
	"field-mon-relative+0": "mánudagur í þessari viku",
	"field-mon-relative+1": "mánudagur í næstu viku",
	"dateFormat-short": "d.M.y",
	"dateFormatItem-EHms": "E, HH:mm:ss",
	"dateFormatItem-Ehms": "E, h:mm:ss a",
	"field-second": "sekúnda",
	"field-sat-relative+-1": "laugardagur í síðustu viku",
	"dateFormatItem-yMMMEd": "E, d. MMM y",
	"field-sun-relative+-1": "sunnudagur í síðustu viku",
	"field-month-relative+0": "í þessum mánuði",
	"field-month-relative+1": "í næsta mánuði",
	"dateFormatItem-Ed": "E d.",
	"dateTimeFormats-appendItem-Timezone": "{0} {1}",
	"field-week": "vika",
	"dateFormat-medium": "d. MMM y",
	"field-year-relative+0": "á þessu ári",
	"field-week-relative+-1": "í síðustu viku",
	"field-year-relative+1": "á næsta ári",
	"dayPeriods-format-narrow-pm": "e.h.",
	"dateTimeFormat-short": "{1}, {0}",
	"dateFormatItem-Hms": "HH:mm:ss",
	"dateFormatItem-hms": "h:mm:ss a",
	"dateFormatItem-GyMMM": "MMM y G",
	"field-mon-relative+-1": "mánudagur í síðustu viku",
	"field-week-relative+0": "í þessari viku",
	"field-week-relative+1": "í næstu viku"
}
//end v1.x content
);
