/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormatItem-Ehm": "E h:mm a",
	"days-standAlone-short": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"months-format-narrow": [
		"जा",
		"फे",
		"मा",
		"ए",
		"मे",
		"जू",
		"जु",
		"ऑ",
		"स",
		"ऑ",
		"नो",
		"डि"
	],
	"field-second-relative+0": "आत्ता",
	"quarters-standAlone-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-weekday": "आठवड्याचा दिवस",
	"dateFormatItem-yQQQ": "QQQ y",
	"dateFormatItem-yMEd": "E, d/M/y",
	"field-wed-relative+0": "हा बुधवार",
	"field-wed-relative+1": "पुढील बुधवार",
	"dateFormatItem-GyMMMEd": "E, d MMM, G y",
	"dateFormatItem-MMMEd": "E, d MMM",
	"eraNarrow": [
		"ईसापूर्व",
		"ईसापूर्व युग",
		"सन",
		"ईसायुग"
	],
	"dateFormatItem-yMM": "MM-y",
	"field-tue-relative+-1": "मागील मंगळवार",
	"days-format-short": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"dateFormat-long": "d MMMM, y",
	"field-fri-relative+-1": "मागील शुक्रवार",
	"field-wed-relative+-1": "मागील बुधवार",
	"months-format-wide": [
		"जानेवारी",
		"फेब्रुवारी",
		"मार्च",
		"एप्रिल",
		"मे",
		"जून",
		"जुलै",
		"ऑगस्ट",
		"सप्टेंबर",
		"ऑक्टोबर",
		"नोव्हेंबर",
		"डिसेंबर"
	],
	"dateTimeFormat-medium": "{1}, {0}",
	"dayPeriods-format-wide-pm": "[PM]",
	"dateFormat-full": "EEEE, d MMMM, y",
	"field-thu-relative+-1": "मागील गुरुवार",
	"dateFormatItem-Md": "d/M",
	"dayPeriods-format-abbr-am": "AM",
	"dateFormatItem-yMd": "d/M/y",
	"field-era": "युग",
	"dateFormatItem-yM": "M/y",
	"months-standAlone-wide": [
		"जानेवारी",
		"फेब्रुवारी",
		"मार्च",
		"एप्रिल",
		"मे",
		"जून",
		"जुलै",
		"ऑगस्ट",
		"सप्टेंबर",
		"ऑक्टोबर",
		"नोव्हेंबर",
		"डिसेंबर"
	],
	"timeFormat-short": "h:mm a",
	"quarters-format-wide": [
		"प्रथम तिमाही",
		"द्वितीय तिमाही",
		"तृतीय तिमाही",
		"चतुर्थ तिमाही"
	],
	"dateFormatItem-yQQQQ": "QQQQ y",
	"timeFormat-long": "h:mm:ss a z",
	"field-year": "वर्ष",
	"dateFormatItem-yMMM": "MMM y",
	"field-hour": "तास",
	"dateFormatItem-MMdd": "dd-MM",
	"months-format-abbr": [
		"जाने",
		"फेब्रु",
		"मार्च",
		"एप्रि",
		"मे",
		"जून",
		"जुलै",
		"ऑग",
		"सप्टें",
		"ऑक्टो",
		"नोव्हें",
		"डिसें"
	],
	"field-sat-relative+0": "हा शनिवार",
	"field-sat-relative+1": "पुढील शनिवार",
	"timeFormat-full": "h:mm:ss a zzzz",
	"field-day-relative+0": "आज",
	"field-thu-relative+0": "हा गुरुवार",
	"field-day-relative+1": "उद्या",
	"field-thu-relative+1": "पुढील गुरुवार",
	"dateFormatItem-GyMMMd": "d MMM, G y",
	"dateFormatItem-H": "HH",
	"months-standAlone-abbr": [
		"जाने",
		"फेब्रु",
		"मार्च",
		"एप्रि",
		"मे",
		"जून",
		"जुलै",
		"ऑग",
		"सप्टें",
		"ऑक्टो",
		"नोव्हें",
		"डिसें"
	],
	"quarters-format-abbr": [
		"ति1",
		"ति2",
		"ति3",
		"ति4"
	],
	"quarters-standAlone-wide": [
		"प्रथम तिमाही",
		"द्वितीय तिमाही",
		"तृतीय तिमाही",
		"चतुर्थ तिमाही"
	],
	"dateFormatItem-Gy": "G y",
	"dateFormatItem-M": "L",
	"days-standAlone-wide": [
		"रविवार",
		"सोमवार",
		"मंगळवार",
		"बुधवार",
		"गुरुवार",
		"शुक्रवार",
		"शनिवार"
	],
	"dateFormatItem-MMMMd": "d MMMM",
	"timeFormat-medium": "h:mm:ss a",
	"field-sun-relative+0": "हा रविवार",
	"dateFormatItem-Hm": "H:mm",
	"field-sun-relative+1": "पुढील रविवार",
	"quarters-standAlone-abbr": [
		"ति1",
		"ति2",
		"ति3",
		"ति4"
	],
	"eraAbbr": [
		"ईसापूर्व",
		"ईसापूर्व युग",
		"सन",
		"ईसायुग"
	],
	"field-minute": "मिनिट",
	"field-dayperiod": "[AM/PM]",
	"days-standAlone-abbr": [
		"रवि",
		"सोम",
		"मंगळ",
		"बुध",
		"गुरु",
		"शुक्र",
		"शनि"
	],
	"dateFormatItem-d": "d",
	"dateFormatItem-ms": "mm:ss",
	"quarters-format-narrow": [
		"1",
		"2",
		"3",
		"4"
	],
	"field-day-relative+-1": "काल",
	"dateFormatItem-h": "h a",
	"dateTimeFormat-long": "{1} 'रोजी' {0}",
	"dayPeriods-format-narrow-am": "AM",
	"dateFormatItem-MMMd": "d MMM",
	"dateFormatItem-MEd": "E, d/M",
	"dateTimeFormat-full": "{1} 'रोजी' {0}",
	"field-fri-relative+0": "हा शुक्रवार",
	"dateFormatItem-yMMMM": "MMMM y",
	"field-fri-relative+1": "पुढील शुक्रवार",
	"field-day": "दिवस",
	"days-format-wide": [
		"रविवार",
		"सोमवार",
		"मंगळवार",
		"बुधवार",
		"गुरुवार",
		"शुक्रवार",
		"शनिवार"
	],
	"field-zone": "वेळ क्षेत्र",
	"dateFormatItem-y": "y",
	"months-standAlone-narrow": [
		"जा",
		"फे",
		"मा",
		"ए",
		"मे",
		"जू",
		"जु",
		"ऑ",
		"स",
		"ऑ",
		"नो",
		"डि"
	],
	"field-year-relative+-1": "मागील वर्ष",
	"field-month-relative+-1": "मागील महिना",
	"dateFormatItem-hm": "h:mm a",
	"dayPeriods-format-abbr-pm": "PM",
	"days-format-abbr": [
		"रवि",
		"सोम",
		"मंगळ",
		"बुध",
		"गुरु",
		"शुक्र",
		"शनि"
	],
	"eraNames": [
		"ईसवीसनपूर्व",
		"ईसवीसन",
		"सन",
		"ईसायुग"
	],
	"dateFormatItem-yMMMd": "d MMM, y",
	"days-format-narrow": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"days-standAlone-narrow": [
		"र",
		"सो",
		"मं",
		"बु",
		"गु",
		"शु",
		"श"
	],
	"dateFormatItem-MMM": "LLL",
	"field-month": "महिना",
	"field-tue-relative+0": "हा मंगळवार",
	"field-tue-relative+1": "पुढील मंगळवार",
	"dayPeriods-format-wide-am": "[AM]",
	"dateFormatItem-EHm": "E HH:mm",
	"field-mon-relative+0": "हा सोमवार",
	"field-mon-relative+1": "पुढील सोमवार",
	"dateFormat-short": "d/M/yy",
	"dateFormatItem-EHms": "E HH:mm:ss",
	"dateFormatItem-Ehms": "E h:mm:ss a",
	"field-second": "सेकंद",
	"field-sat-relative+-1": "मागील शनिवार",
	"dateFormatItem-yMMMEd": "E, d, MMM y",
	"field-sun-relative+-1": "मागील रविवार",
	"field-month-relative+0": "हा महिना",
	"field-month-relative+1": "पुढील महिना",
	"dateFormatItem-Ed": "d E",
	"dateTimeFormats-appendItem-Timezone": "{0} {1}",
	"field-week": "आठव़डा",
	"dateFormat-medium": "d MMM, y",
	"field-year-relative+0": "हे वर्ष",
	"field-week-relative+-1": "मागील आठवडा",
	"field-year-relative+1": "पुढील वर्ष",
	"dayPeriods-format-narrow-pm": "PM",
	"dateTimeFormat-short": "{1}, {0}",
	"dateFormatItem-Hms": "H:mm:ss",
	"dateFormatItem-hms": "h:mm:ss a",
	"dateFormatItem-GyMMM": "MMM G y",
	"field-mon-relative+-1": "मागील सोमवार",
	"field-week-relative+0": "हा आठवडा",
	"field-week-relative+1": "पुढील आठवडा"
}
//end v1.x content
);
