/*
 * Licensed Materials - Property of IBM
 *
 * 5724-U18, 5737-M66
 *
 * (C) Copyright IBM Corp. 2023 All Rights Reserved
 *
 * US Government Users Restricted Rights - Use, duplication or
 * disclosure restricted by GSA ADP Schedule Contract with
 * IBM Corp.
 */

define(
//begin v1.x content
{
	"dateFormat-medium": "d MMM y",
	"dateFormatItem-MMdd": "dd-MM",
	"months-format-narrow": [
		"ଜା",
		"ଫେ",
		"ମା",
		"ଅ",
		"ମେ",
		"ଜୁ",
		"ଜୁ",
		"ଅ",
		"ସେ",
		"ଅ",
		"ନ",
		"ଡି"
	],
	"timeFormat-full": "h:mm:ss a zzzz",
	"days-format-short": [
		"ରବି",
		"ସୋମ",
		"ମଙ୍ଗଳ",
		"ବୁଧ",
		"ଗୁରୁ",
		"ଶୁକ୍ର",
		"ଶନି"
	],
	"months-standAlone-narrow": [
		"ଜା",
		"ଫେ",
		"ମା",
		"ଅ",
		"ମେ",
		"ଜୁ",
		"ଜୁ",
		"ଅ",
		"ସେ",
		"ଅ",
		"ନ",
		"ଡି"
	],
	"months-standAlone-wide": [
		"ଜାନୁଆରୀ",
		"ଫେବ୍ରୁୟାରୀ",
		"ମାର୍ଚ୍ଚ",
		"ଅପ୍ରେଲ",
		"ମେ",
		"ଜୁନ",
		"ଜୁଲାଇ",
		"ଅଗଷ୍ଟ",
		"ସେପ୍ଟେମ୍ବର",
		"ଅକ୍ଟୋବର",
		"ନଭେମ୍ବର",
		"ଡିସେମ୍ବର"
	],
	"days-standAlone-narrow": [
		"ର",
		"ସୋ",
		"ମ",
		"ବୁ",
		"ଗୁ",
		"ଶୁ",
		"ଶ"
	],
	"dayPeriods-format-wide-pm": "pm",
	"dateFormatItem-MMMMd": "MMMM d",
	"months-standAlone-abbr": [
		"ଜାନୁଆରୀ",
		"ଫେବ୍ରୁୟାରୀ",
		"ମାର୍ଚ୍ଚ",
		"ଅପ୍ରେଲ",
		"ମେ",
		"ଜୁନ",
		"ଜୁଲାଇ",
		"ଅଗଷ୍ଟ",
		"ସେପ୍ଟେମ୍ବର",
		"ଅକ୍ଟୋବର",
		"ନଭେମ୍ବର",
		"ଡିସେମ୍ବର"
	],
	"dateFormatItem-yQQQ": "QQQ y",
	"days-standAlone-short": [
		"ରବି",
		"ସୋମ",
		"ମଙ୍ଗଳ",
		"ବୁଧ",
		"ଗୁରୁ",
		"ଶୁକ୍ର",
		"ଶନି"
	],
	"dayPeriods-format-wide-am": "am",
	"timeFormat-medium": "h:mm:ss a",
	"dateFormatItem-yMM": "MM-y",
	"dateFormat-long": "d MMMM y",
	"dateFormat-short": "d-M-yy",
	"months-format-wide": [
		"ଜାନୁଆରୀ",
		"ଫେବ୍ରୁୟାରୀ",
		"ମାର୍ଚ୍ଚ",
		"ଅପ୍ରେଲ",
		"ମେ",
		"ଜୁନ",
		"ଜୁଲାଇ",
		"ଅଗଷ୍ଟ",
		"ସେପ୍ଟେମ୍ବର",
		"ଅକ୍ଟୋବର",
		"ନଭେମ୍ବର",
		"ଡିସେମ୍ବର"
	],
	"dateFormatItem-yMMMM": "MMMM y",
	"days-standAlone-wide": [
		"ରବିବାର",
		"ସୋମବାର",
		"ମଙ୍ଗଳବାର",
		"ବୁଧବାର",
		"ଗୁରୁବାର",
		"ଶୁକ୍ରବାର",
		"ଶନିବାର"
	],
	"days-format-narrow": [
		"ର",
		"ସୋ",
		"ମ",
		"ବୁ",
		"ଗୁ",
		"ଶୁ",
		"ଶ"
	],
	"dayPeriods-format-narrow-pm": "pm",
	"timeFormat-short": "h:mm a",
	"months-format-abbr": [
		"ଜାନୁଆରୀ",
		"ଫେବ୍ରୁୟାରୀ",
		"ମାର୍ଚ୍ଚ",
		"ଅପ୍ରେଲ",
		"ମେ",
		"ଜୁନ",
		"ଜୁଲାଇ",
		"ଅଗଷ୍ଟ",
		"ସେପ୍ଟେମ୍ବର",
		"ଅକ୍ଟୋବର",
		"ନଭେମ୍ବର",
		"ଡିସେମ୍ବର"
	],
	"days-standAlone-abbr": [
		"ରବି",
		"ସୋମ",
		"ମଙ୍ଗଳ",
		"ବୁଧ",
		"ଗୁରୁ",
		"ଶୁକ୍ର",
		"ଶନି"
	],
	"days-format-wide": [
		"ରବିବାର",
		"ସୋମବାର",
		"ମଙ୍ଗଳବାର",
		"ବୁଧବାର",
		"ଗୁରୁବାର",
		"ଶୁକ୍ରବାର",
		"ଶନିବାର"
	],
	"timeFormat-long": "h:mm:ss a z",
	"dayPeriods-format-narrow-am": "am",
	"dateFormat-full": "EEEE, d MMMM y",
	"days-format-abbr": [
		"ରବି",
		"ସୋମ",
		"ମଙ୍ଗଳ",
		"ବୁଧ",
		"ଗୁରୁ",
		"ଶୁକ୍ର",
		"ଶନି"
	]
}
//end v1.x content
);
