#!/bin/sh 

# *************************************************************************
# This script is used to initialize common maximo environment variables.
#
# Here is the list of variables.
#
# MAXIMO_HOME
#
# MAXIMO_CLASSPATH
#
# *************************************************************************


# MAXIMO_HOME
if [ -z "$SUBDIR" ] ; 
  then 
    if [ "$1" != "" ] ; then
       export MAXIMO_HOME=$1/../..
    else
       export MAXIMO_HOME=../..
    fi
  else 
    export MAXIMO_HOME="$SUBDIR/../.."
fi
unset SUBDIR

# MAXIMO_ROOT
export MAXIMO_ROOT=$MAXIMO_HOME/applications/maximo
export MAXIMO_TOOLS=$MAXIMO_HOME/tools/maximo

# MAXIMO_LIB_PATH
export MAXIMO_LIB_PATH=$MAXIMO_ROOT/lib

# echo "in tools/maximo/commonenv.sh"
# echo "MAXIMO_LIB_PATH exported as $MAXIMO_LIB_PATH" 

# MAXIMO_COMMON_LIBS
export MAXIMO_COMMON_LIBS=$MAXIMO_ROOT/properties:$MAXIMO_ROOT/resources:$MAXIMO_ROOT/businessobjects/classes:$MAXIMO_ROOT/maximouiweb/webmodule/WEB-INF/classes:$MAXIMO_LIB_PATH/j2ee.jar:$MAXIMO_LIB_PATH/log4j-1.2-api-2.17.1.jar:$MAXIMO_LIB_PATH/log4j-api-2.17.1.jar:$MAXIMO_LIB_PATH/log4j-core-2.17.1.jar:$MAXIMO_LIB_PATH/log4j-web-2.17.1.jar:$MAXIMO_LIB_PATH/bcel-6.6.1.jar:$MAXIMO_LIB_PATH/tools.jar:$MAXIMO_LIB_PATH/icu4j.jar:$MAXIMO_LIB_PATH/json4j.jar:$MAXIMO_LIB_PATH/gson-2.8.9.jar:$MAXIMO_LIB_PATH/aws-java-sdk-core-1.12.267.jar:$MAXIMO_LIB_PATH/aws-java-sdk-kms-1.12.267.jar:$MAXIMO_LIB_PATH/aws-java-sdk-s3-1.12.267.jar:$MAXIMO_LIB_PATH/jackson-dataformat-cbor-2.12.3.jar:$MAXIMO_LIB_PATH/jmespath-java-1.12.54.jar:$MAXIMO_LIB_PATH/ion-java-1.10.5.jar:$MAXIMO_LIB_PATH/commons-codec-1.15.jar:$MAXIMO_LIB_PATH/commons-logging-1.2.jar:$MAXIMO_LIB_PATH/jackson-annotations-2.15.1.jar:$MAXIMO_LIB_PATH/jackson-core-2.15.1.jar:$MAXIMO_LIB_PATH/jackson-core-asl-1.9.13.jar:$MAXIMO_LIB_PATH/jackson-databind-2.15.1.jar:$MAXIMO_LIB_PATH/httpclient-4.5.13.jar:$MAXIMO_LIB_PATH/httpcore-4.4.13.jar:$MAXIMO_LIB_PATH/joda-time-2.8.1.jar:$MAXIMO_LIB_PATH/oraclethin.jar:$MAXIMO_TOOLS/automation/lib/mail.jar:$MAXIMO_LIB_PATH/icu4j.jar

# MAXIMO_DB_LIBS
export MAXIMO_DB_LIBS=$MAXIMO_LIB_PATH/oraclethin.jar:$MAXIMO_LIB_PATH/Opta.jar:$MAXIMO_LIB_PATH/sqljdbc.jar:$MAXIMO_LIB_PATH/db2jcc.jar:$MAXIMO_LIB_PATH/db2jcc_license_cu.jar:$MAXIMO_LIB_PATH/jaxen-1.1-beta-8.jar:$MAXIMO_LIB_PATH/jtds-1.3.1.jar

# MAXIMO_XML_LIBS
export MAXIMO_XML_LIBS=$MAXIMO_LIB_PATH/jdom.jar:$MAXIMO_LIB_PATH/xercersImpl.jar

# MAXIMO_MEA_LIBS
export MAXIMO_MEA_LIBS=$MAXIMO_LIB_PATH/jaxrpc.jar:$MAXIMO_LIB_PATH/uddi4j.jar:$MAXIMO_LIB_PATH/wsdl4j.jar:$MAXIMO_LIB_PATH/jaxen-full.jar:$MAXIMO_LIB_PATH/saxpath.jar::$MAXIMO_LIB_PATH/commons-discovery.jar:$MAXIMO_LIB_PATH/commons-logging-1.2.jar:$MAXIMO_LIB_PATH/axis.jar:$MAXIMO_LIB_PATH/axis-ant.jar:$MAXIMO_XML_LIBS

# MAXIMO_REPORT
MAXIMO_REPORT=$MAXIMO_HOME/reports/birt/tools/classes


# MAXIMO_CLASSPATH
# export MAXIMO_CLASSPATH=.:$MAXIMO_COMMON_LIBS:$MAXIMO_DB_LIBS
export MAXIMO_CLASSPATH=.:$MAXIMO_COMMON_LIBS:$MAXIMO_DB_LIBS:$MAXIMO_XML_LIBS:$MAXIMO_REPORT

export MEMORY_ARGS=-Xmx1024m

# optional parameter, for example -Djava.net.preferIPv4Stack=true
export IPV_ARGS=